<html>
<head>
	<title>crush sequencer</title>
	<style type="text/css">
	body { font-family: sans-serif; }
	p { max-width: 40em; }
	ul { padding: 0; list-style-type: none; }
	</style>
</head>

<body>
<h1>codename: crush sequencer</h1>

<h2>summary:</h2>
<p>It's a midi sequencer. It is a state machine mainly consisting of
midi events arranged in time (with some structure convenient for
editing) and also some auxilliary machinery to support certain
editing operations.</p>

<p>It has two main functions which it carries out concurrently: it
plays back the events synchronous with some callback framework,
and it allows a client app to make concurrent changes to the sequence.</p>

<h2>metaphor:</h2>
<p>Think of it as a tape deck with buttons that read and write to
the tape (the client app's interface) and two ports for audio out
(midi out) and mic input (for recording input). When the tape is
playing, or recording, the user has no direct control over the
behavior of the I/O port.</p>


<h2>realtime audio:</h2>
<p>To support realtime operation, time consuming processes like memory
management are only initiated by actions of the client code, not
the I/O callback code.</p>


<h2>features intentionally missing:</h2>
<p>There are some higher level operations a midi sequencer might be
expected to have, but they are not provided at this level and
should be implemented as a layer on top. The idea here is to only
address the complexity of multithreaded audio programming, realtime
memory management, low level data consistency, timing, and undo/redo.</p>


<h2>details:</h2>
<p>This documentation attempt will explain the structure of the events,
possible editing operations, the asynchronous i/o interface, and
the few extra features of the sequencer (auto cutoff).</p>


<h2>structures:</h2>
<ul>
<li>the sequencer has zero or more tracks</li>
<li>tracks have chan and port, and contain a sequence of blocks</li>
<li>blocks have length and have one or more references to chunks</li>
<li>chunks have a color and contain a sequence of events</li>
<li>events are basic midi events without channel</li>
</ul>

<h2>blocks and chunks:</h2>
<p>Blocks may reference more than one chunk, but only one chunk
is active at a given time. These are sometimes called
layers but they dont have a separate name here except
the chunks in the block. Blocks may share chunks, changes
to one chunk show up in another block immediately.</p>

<h2>nonstandard api description:</h2>
<p>The api will be described abstractly, but more clearly than a C
header file. The C signatures are listed in the seq.h header file.
A method listed as X -&gt; Y is a procedure that takes arguments X and
produces Y. The word effects in the Y part is used to signify that
using this operation changes the sequencers internal state. Possible
memory allocation is not considered an effect. If an operation takes no
arguments it is listed without the X -&gt;. If a value is listed with
a ? suffix, it means it may be NULL. The possibility of having no
effect at all is not considered to be ?. The possibility of failure to
allocate memory is not considered to be ?. See the section on custom
memory management. The expression Y + effects is used when a procedure
results in effects and values. in C effects are not values. Read + as
'in addition to'. when there are more than one result values, the
C api will use passed-in pointers to write some of the results.</p>

<h2>client interface:</h2>
<p>The 'gui thread', client code that provides a user interface to the
sequence, has several operations available to support playback, editing,
undo/redo, time config, looping (between two global static times),
outputting an immediate event (not scheduled), and reading back data
for display purposes.</p>

<h2>editing:</h2>
<pre>
seq_add_track        :: effects
seq_delete_track     :: track -&gt; effects
seq_insert_block     :: (track, tick, length, chunk) -&gt; effects
seq_copy_block       :: (block, track, tick) -&gt; effects
seq_resize_block     :: (block,length) -&gt; effects
seq_delete_block     :: (track,block) -&gt; effects
seq_push_chunk       :: (block,chunk) -&gt; effects
seq_rrotate_chunk    :: block -&gt; effects
seq_lrotate_chunk    :: block -&gt; effects
seq_insert_event     :: (chunk,tick,type,u,v) -&gt; effects
seq_delete_event     :: (chunk,event) --&gt; effects
seq_accept_recording :: effects
</pre>

<h2>playback:</h2>
<pre>
seq_play             :: enable -&gt; effects
seq_poll             :: tick_now
seq_seek             :: tick -&gt; effects
seq_reset            :: effects
seq_record           :: enable -&gt; effects
seq_set_record_track :: index -&gt; effects
seq_loop             :: enable -&gt; effects
seq_loop_limits      :: (tick1,tick2) -&gt; effects
seq_time_config      :: (srate, tpb, bpm) -&gt; effects
seq_all_notes_off    :: effects
</pre>

<h2>misc:</h2>
<pre>
seq_init      :: (alloc?,free?,oom?) -&gt; effects
seq_uninit    :: effects
seq_undo      :: effects
seq_redo      :: effects
seq_commit    :: effects
seq_clear_all :: effects
seq_instant   :: (track,type,u,v) -&gt; effects
seq_mk_chunk  :: chunk
</pre>

<h2>traversal:</h2>
<pre>
seq_layer_number :: block -&gt; index
seq_walk_tracks  :: effects
seq_next_track   :: track? + effects
seq_walk_blocks  :: track -&gt; effects
seq_next_block   :: block? + effects
seq_walk_events  :: chunk -&gt; effects
seq_next_event   :: event? + effects
</pre>




<h2>sequence data is public:</h2>
<p>The structures which represent the tracks, blocks, chunks and events
are publically exposed to avoid a giant interface to simply read the
fields. Some fields are meant to be read/write to avoid a get/set
interface. These are listed in the header file. Some fields are
better not used by client code, these are not listed as read nor
read/write in the header file.</p>

<h2>custom memory management:</h2>
<p>The client code may request memory be dynamically allocated. seq_init
accepts up to three routines which handle this as the client code sees
fit. alloc should deliver a pointer to newly allocated memory of the
desired size. free should release the memory pointed to by the argument.
oom is a routine to handle the case where alloc fails. By passing NULL
in for any of these, the default allocator will be used (std malloc).
Please provide both alloc and free or neither of them because your
custom allocator is probably not compatible with the default free and
vice versa. The default oom handler writes a message to stderr and
exits with code 13, so its compatible with anything.</p>

<p>oom may either find more memory and report success, it may report 
failure, or it may choose to not return (exit the program). If it
reports failure, then the internal sequencer will use emergency static
allocated storage in order to return from the current operation without 
incident. After this you are guarantee not to have a reliable sequencer, 
so the oom routine should consider cutting off the client code from the 
sequencer a high priority. If using the tape deck analogy from above, 
think of oom failure as either causing the tape deck itself to explode, 
or to leave it intact, but might explode the next time it is operated.</p>




<h2>asynchronous i/o interface:</h2>
<p>The 'audio thread' which represents the cable carrying playback
events and delivering input events to the recorder takes the form
of two operations:</p>

<pre>
seq_advance :: sample_count -&gt; (status, nused, port, type, chan, u, v) + effects
seq_record_event :: (type, chan, u, v) -&gt; effects
</pre>

<p>The audio driver charged with handling the next N samples of sequence
should use seq_advance to advance the sequencer and return the next
event if any. You know when there are no events left by looking at the
status code. The number of samples actually advanced is returned. If this
number if less than N then the driver code needs to continue extracting
events.</p>

<p>The audio driver with incoming midi events should dump them to the
sequencer with seq_record_event. The module will internally decide
to ignore them or to record them. Because editing of the sequence
might cause memory management record will be deferred until the client
thread issues a periodic 'accept_recording' signal. accept_recording
is only necessary if recording has been enabled by the client code.
When recording is disabled, any pending events will be expunged, future
events ignored.</p>





<h2>auto-cutoff:</h2>
<p>This sequencer comes with a fancy auto note-off mechanism which
will send note offs for any note ons which have not be cut when
the client code stops playback. It will also auto cut notes which
are on during editting operations that could result in stuck notes.
this feature is tricky so sometimes more notes are cut than necessary.</p>


<h2>undo/redo:</h2>
<p>Editting of sequence events can be undone. To support higher level
operations that are undone with fewer steps, undoing works with
commits. After completing an operation you wish to be able to totally
undo, commit the changes. Redo will redo all changes until a commit.
editing will clear any redoable actions on the stack.</p>




</body>
</html>
